import { getNotificationContainer } from '../notification-util';
/**
 * Shows the dialog
 * @internal
 * @param notification - The NotificationStructure object
 * @param tagName - The tag name to create prefix for the design system provider & notification component
 * @returns
 * */
export const showDialog = (notification, tagName) => {
    const tagPrefix = tagName.split('-')[0];
    const dialog = document.createElement(`${tagPrefix}-notification-dialog`);
    const container = getNotificationContainer('dialog-container', tagName);
    container.appendChild(dialog);
    dialog.notification = notification;
    dialog.show();
};
