## API Report File for "@genesislcap/foundation-notifications"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import { LogLevel } from '@genesislcap/foundation-utils';

// @public
export interface Banner {
    // (undocumented)
    readonly confirmingActions?: Array<ConfirmingAction>;
    // (undocumented)
    readonly dismissingAction?: DismissingAction;
}

// @public
export class BannerBuilder {
    build(): Banner;
    withConfirmingAction(confirmingAction: ConfirmingAction): BannerBuilder;
    withDismissingAction(dismissingAction: DismissingAction): BannerBuilder;
}

// @public
export interface ConfirmingAction {
    // (undocumented)
    readonly action: Function;
    // (undocumented)
    readonly label: String;
}

// @public
export interface Dialog {
    // (undocumented)
    readonly confirmingActions?: Array<ConfirmingAction>;
    // (undocumented)
    readonly dismissingAction?: DismissingAction;
}

// @public
export class DialogBuilder {
    build(): Dialog;
    withConfirmingAction(confirmingAction: ConfirmingAction): DialogBuilder;
    withDismissingAction(dismissingAction: DismissingAction): DialogBuilder;
}

// Warning: (ae-internal-missing-underscore) The name "DialogElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type DialogElement = NotificationElement & {
    show: Function;
};

// @public
export interface DismissingAction {
    // (undocumented)
    readonly action?: Function;
    // (undocumented)
    readonly label: String;
}

// @public
export const getBannerAnchor: (element: any) => HTMLElement | null;

// @public
export const getBannerBuilder: () => BannerBuilder;

// @public
export const getDialogBuilder: () => DialogBuilder;

// @public
export const getLoglevel: (details: NotificationStructure) => LogLevel;

// @public
export const getNotificationBuilder: () => NotificationBuilder;

// @public
export const getNotificationContainer: (id: string, tagName: String) => HTMLElement;

// @public
export const getNotificationDetails: (details: NotificationStructure) => string;

// @public
export const getSnackbarBuilder: () => SnackbarBuilder;

// @public
export const getToastBuilder: () => ToastBuilder;

// @public
export class NotificationBuilder {
    build(): NotificationStructure;
    withAlert(alert: boolean): NotificationBuilder;
    withBanner(banner: Banner): NotificationBuilder;
    withBody(body: string): NotificationBuilder;
    withCreatedAt(createdAt: Date): NotificationBuilder;
    withDialog(dialog: Dialog): NotificationBuilder;
    withLogLevel(logLevel: LogLevel): NotificationBuilder;
    withSnackbar(snackbar: Snackbar): NotificationBuilder;
    withTitle(title: string): NotificationBuilder;
    withToast(toast: Toast): NotificationBuilder;
}

// @public
export interface NotificationDataRow {
    // (undocumented)
    ALERT_ID: string;
    // (undocumented)
    CREATED_AT: number;
    // (undocumented)
    DETAILS: {
        OPERATION: string;
        ROW_REF: string;
    };
    // (undocumented)
    EXPIRY?: null;
    // (undocumented)
    HEADER: string;
    // (undocumented)
    MESSAGE: string;
    // (undocumented)
    NOTIFY_SEVERITY: NotificationSeverity;
    // (undocumented)
    SENDER?: null;
    // (undocumented)
    TABLE_ENTITY_ID: string;
    // (undocumented)
    TOPIC: string;
    // (undocumented)
    USER_NAME: string;
}

// Warning: (ae-internal-missing-underscore) The name "NotificationElement" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal (undocumented)
export type NotificationElement = HTMLElement & {
    notification: NotificationStructure;
};

// @public
export enum NotificationEvent {
    // (undocumented)
    NOTIFICATION_EVENT = "notification-event"
}

// @public
export type NotificationSeverity = 'Information' | 'Warning' | 'Serious' | 'Critical';

// @public
export interface NotificationStructure {
    // (undocumented)
    readonly body: string;
    // (undocumented)
    readonly config?: {
        readonly logLevel?: LogLevel;
        readonly alert?: boolean;
        readonly toast?: Toast;
        readonly banner?: Banner;
        readonly snackbar?: Snackbar;
        readonly dialog?: Dialog;
    };
    // (undocumented)
    readonly createdAt?: Date;
    // (undocumented)
    readonly logLevel?: LogLevel;
    // (undocumented)
    readonly title: string;
}

// @public
export type NotificationType = 'error' | 'warning' | 'success';

// @public
export const showBanner: (notificationStructure: NotificationStructure, tagName: String, notificationBoundary: HTMLElement) => void;

// Warning: (ae-internal-missing-underscore) The name "showDialog" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const showDialog: (notification: NotificationStructure, tagName: String) => void;

// @public
export const showNotification: (notificationStructure: NotificationStructure, tagName: String, notificationBoundary?: HTMLElement) => void;

// Warning: (ae-internal-missing-underscore) The name "showSnackbar" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const showSnackbar: (notification: NotificationStructure, tagName: String) => void;

// Warning: (ae-internal-missing-underscore) The name "showToast" should be prefixed with an underscore because the declaration is marked as @internal
//
// @internal
export const showToast: (notificationStructure: NotificationStructure, tagName: String) => void;

// @public
export interface Snackbar {
    // (undocumented)
    readonly confirmingActions?: Array<ConfirmingAction>;
    // (undocumented)
    readonly type?: SnackbarType;
}

// @public
export class SnackbarBuilder {
    build(): Snackbar;
    withConfirmingAction(confirmingAction: ConfirmingAction): SnackbarBuilder;
    // (undocumented)
    withType(type: SnackbarType): SnackbarBuilder;
}

// @public
export type SnackbarType = 'error';

// @public
export interface Toast {
    // (undocumented)
    readonly autoClose?: boolean;
    // (undocumented)
    readonly buttons?: ToastButton[];
    // (undocumented)
    readonly closeTimeout?: number;
    // (undocumented)
    readonly details?: NotificationDataRow;
    // (undocumented)
    readonly position?: ToastPosition;
    // (undocumented)
    readonly type?: NotificationType;
}

// @public (undocumented)
export class ToastBuilder {
    build(): Toast;
    withAutoClose(autoClose: boolean): ToastBuilder;
    withButtons(buttons: ToastButton[]): ToastBuilder;
    withCloseTimeout(closeTimeout: number): ToastBuilder;
    withDetails(details: NotificationDataRow): ToastBuilder;
    withPosition(position: ToastPosition): ToastBuilder;
    withType(type: NotificationType): ToastBuilder;
}

// @public
export interface ToastButton {
    // (undocumented)
    action({ details, buttonElement, toastElement, }: {
        details: NotificationDataRow;
        buttonElement: HTMLElement;
        toastElement: any;
    }): void;
    // (undocumented)
    appearance?: string;
    // (undocumented)
    condition({ details }?: {
        details: NotificationDataRow;
    }): boolean;
    // (undocumented)
    placeholder?: string;
}

// @public
export type ToastPosition = 'top-left' | 'top-right' | 'bottom-left' | 'bottom-right';

// (No @packageDocumentation comment for this package)

```
